=== added file 'docs/administrative.rst'
--- docs/administrative.rst	1970-01-01 00:00:00 +0000
+++ docs/administrative.rst	2010-10-27 21:00:49 +0000
@@ -0,0 +1,10 @@
+ADMINISTRATIVE 
+==============
+
+KILL
+
+FLUSH 
+
+ANALYZE
+
+UNLOCK

=== added file 'docs/alter_schema.rst'
--- docs/alter_schema.rst	1970-01-01 00:00:00 +0000
+++ docs/alter_schema.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,2 @@
+ALTER SCHEMA
+============

=== added file 'docs/alter_table.rst'
--- docs/alter_table.rst	1970-01-01 00:00:00 +0000
+++ docs/alter_table.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,2 @@
+ALTER TABLE
+===========

=== modified file 'docs/columntypes.rst'
--- docs/columntypes.rst	2010-10-12 00:06:15 +0000
+++ docs/columntypes.rst	2010-10-27 20:46:04 +0000
@@ -47,3 +47,11 @@
 Enum (enumerated) types are static lists of strings that are defineed on
 table creation. They can be used to represent a collection of string types
 that are sorted based on the order that they are created.
+
+------
+SERIAL
+------
+
+A SERIAL is a meta type that creates a column where a number is inserted in
+increasing order as rows are inserted into the table. The actual type is a
+BIGINT.

=== added file 'docs/create_index.rst'
--- docs/create_index.rst	1970-01-01 00:00:00 +0000
+++ docs/create_index.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,11 @@
+CREATE INDEX
+============
+
+CREATE [UNIQUE] INDEX index_name [USING {BTREE | HASH}] ON table_name (column_name [length] [ASC | DESC], ...);
+
+An example:
+
+CREATE INDEX table_1_index ON table_1 (a,b);
+
+This would create an index on table_t named  table_1_index that convered
+columns a and b.

=== added file 'docs/create_schema.rst'
--- docs/create_schema.rst	1970-01-01 00:00:00 +0000
+++ docs/create_schema.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,2 @@
+CREATE SCHEMA
+============

=== added file 'docs/create_table.rst'
--- docs/create_table.rst	1970-01-01 00:00:00 +0000
+++ docs/create_table.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,2 @@
+CREATE TABLE
+===========

=== added file 'docs/data_dictionary.rst'
--- docs/data_dictionary.rst	1970-01-01 00:00:00 +0000
+++ docs/data_dictionary.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,7 @@
+DATA_DICTIONARY
+===============
+
+The DATA_DICTIONARY is a Drizzle extension that provides information on the
+state of the database, and on the definitions of tables and other objects.
+If you wish to write portable tools you show make use of the
+INFORMATION_SCHEMA.

=== modified file 'docs/ddl.rst'
--- docs/ddl.rst	2010-10-12 00:06:15 +0000
+++ docs/ddl.rst	2010-10-27 20:22:26 +0000
@@ -1,10 +1,9 @@
 Data Description Language
 ========
 
-CREATE SCHEMA <>
-ALTER SCHEMA <>
-DROP SCHEMA <>
+.. toctree::
+   :maxdepth: 2
 
-CREATE TABLE <>
-ALTER TABLE <>
-DROP TABLE <>
+   tables
+   schemas
+   indexes

=== added file 'docs/delete.rst'
--- docs/delete.rst	1970-01-01 00:00:00 +0000
+++ docs/delete.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,8 @@
+Deleting Data
+========
+
+In Dizzle you can make use of DELETE in order to delete data from a table.
+
+A type query:
+
+DELETE FROM TABLE_1;

=== added file 'docs/describe.rst'
--- docs/describe.rst	1970-01-01 00:00:00 +0000
+++ docs/describe.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,4 @@
+DESCRIBE
+========
+
+DESCRIBE is an Oracle compatible command that can be used to gain the definition of a TABLE.

=== modified file 'docs/dml.rst'
--- docs/dml.rst	2010-10-12 00:06:15 +0000
+++ docs/dml.rst	2010-10-27 20:22:26 +0000
@@ -1,7 +1,10 @@
 Data Manipulation Language
 ========
 
-INSERT
-UPDATE
-DELETE
-REPLACE
+.. toctree::
+   :maxdepth: 2
+
+   delete
+   insert
+   replace
+   update

=== added file 'docs/drop_index.rst'
--- docs/drop_index.rst	1970-01-01 00:00:00 +0000
+++ docs/drop_index.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,6 @@
+DROP INDEX
+============
+
+This drops a given index on the named table.
+
+DROP INDEX table_1_index ON table_1;

=== added file 'docs/drop_schema.rst'
--- docs/drop_schema.rst	1970-01-01 00:00:00 +0000
+++ docs/drop_schema.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,7 @@
+DROP SCHEMA
+============
+
+DROP SCHEMA removes all tables and related objects from a schema once all queries or DML have ceased
+on them. It then removes the schema itself from the catalog that owned it.
+
+DROP SCHEMA schema_name

=== added file 'docs/drop_table.rst'
--- docs/drop_table.rst	1970-01-01 00:00:00 +0000
+++ docs/drop_table.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,7 @@
+DROP TABLE
+===========
+
+DROP TABLE removes a table from a schema once all queries or DML have ceased
+on the given table.
+
+DROP TABLE table_name

=== added file 'docs/dynamic.rst'
--- docs/dynamic.rst	1970-01-01 00:00:00 +0000
+++ docs/dynamic.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,12 @@
+Dynamic SQL
+========
+
+In Drizzle you can use the EXECUTE command along with user defined variables
+to create SQL in a dynamic manner on the server. An exmaple of this is:
+
+SET @var= "SELECT 1";
+EXECUTE @var;
+
+You can also omit the variable and just insert the SQL directly:
+
+EXECUTE "SELECT 1";

=== added file 'docs/file.rst'
--- docs/file.rst	1970-01-01 00:00:00 +0000
+++ docs/file.rst	2010-10-27 21:19:18 +0000
@@ -0,0 +1,2 @@
+File
+===========

=== added file 'docs/getting_information.rst'
--- docs/getting_information.rst	1970-01-01 00:00:00 +0000
+++ docs/getting_information.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,21 @@
+Obtaining Information on the Contents of the Database
+=====================================================
+
+Drizzle provides two schema per catalog that contain data about the contents
+of the schema, the state of the database instance, and other additional
+information that might be useful to a user. In addition Drizzle supports
+"SHOW" commands, and DESCRIBE, which can be used by a user to gain
+additional information.
+
+The INFORMATION_SCHEMA only contains data that is the SQL standard requires.
+More information can be gained by the tables found in the DATA_DICTIONARY
+schema.
+
+.. toctree::
+   :maxdepth: 2
+
+   data_dictionary
+   information_schema
+   show
+   describe
+

=== modified file 'docs/index.rst'
--- docs/index.rst	2010-10-19 15:33:33 +0000
+++ docs/index.rst	2010-10-27 21:19:18 +0000
@@ -27,9 +27,24 @@
 .. toctree::
    :maxdepth: 2
 
+   queries
    ddl
    dml
-   columntypes
+   columntypes 
+   variables 
+   dynamic 
+   getting_information 
+   transactional 
+   administrative 
+
+Advanced Topics:
+  
+.. toctree::
+   :maxdepth: 2
+
+   storage_engines
+   logging
+
 
 Configuration:
 

=== added file 'docs/indexes.rst'
--- docs/indexes.rst	1970-01-01 00:00:00 +0000
+++ docs/indexes.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,20 @@
+Indexes
+=======
+
+To quote wikipedia, "An index is a data structure that improves the
+speed of data retrieval operations on a database table at the cost of slower
+writes and increased storage space. Indexes can be created using one or more
+columns of a database table, providing the basis for both rapid random
+lookups and efficient access of ordered records. The disk space required to
+store the index is typically less than that required by the table (since
+indexes usually contain only the key-fields according to which the table is
+to be arranged, and exclude all the other details in the table), yielding
+the possibility to store indexes in memory for a table whose data is too
+large to store in memory."
+
+
+.. toctree::
+   :maxdepth: 2
+
+   create_index
+   drop_index

=== added file 'docs/information_schema.rst'
--- docs/information_schema.rst	1970-01-01 00:00:00 +0000
+++ docs/information_schema.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,8 @@
+INFORMATION_SCHEMA
+==================
+
+The INFORMATION_SCHEMA contains only tables and columns defined by the ANSI
+SQL standard. It should be used over DATA_DICTIONARY if you wish to write
+tools portable to other RDBMS.
+
+

=== added file 'docs/insert.rst'
--- docs/insert.rst	1970-01-01 00:00:00 +0000
+++ docs/insert.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,10 @@
+Inserting Data
+========
+
+In Dizzle you can make use of INSERT in order to insert data into a table.
+
+A type query:
+
+INSERT INTO A VALUES ("1");
+
+

=== added file 'docs/logging.rst'
--- docs/logging.rst	1970-01-01 00:00:00 +0000
+++ docs/logging.rst	2010-10-27 21:19:18 +0000
@@ -0,0 +1,10 @@
+Logging
+=======
+
+Drizzle provides a number of logging solutions. 
+
+.. toctree::
+   :maxdepth: 2
+
+   syslog
+   file

=== added file 'docs/queries.rst'
--- docs/queries.rst	1970-01-01 00:00:00 +0000
+++ docs/queries.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,9 @@
+Executing Queries
+========
+
+To return from values from Drizzled you most commonly use the SELECT
+command. An example of this would be:
+
+SELECT * FROM table_1;
+
+

=== added file 'docs/rename.rst'
--- docs/rename.rst	1970-01-01 00:00:00 +0000
+++ docs/rename.rst	2010-10-27 21:00:49 +0000
@@ -0,0 +1,4 @@
+RENAME 
+======
+
+Rename a table, or group of tables.

=== added file 'docs/replace.rst'
--- docs/replace.rst	1970-01-01 00:00:00 +0000
+++ docs/replace.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,18 @@
+Replacing Data
+========
+
+In Dizzle you can make use of REPLACE to insert a new record into a table or
+delete and insert a record in a table if a record matching the primary key
+already exists. If no primary key or unique constraint is found on the table
+then REPLACE is equivalent to INSERT.
+
+A typical query:
+
+REPLACE INTO table_1 SET a=5;
+
+or
+
+REPLACE INTO table_1 VALUES (4);
+
+
+REPLACE is an extension to the SQL Standard that firtst appeared in MySQL.

=== added file 'docs/schemas.rst'
--- docs/schemas.rst	1970-01-01 00:00:00 +0000
+++ docs/schemas.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,18 @@
+Schemas
+=======
+
+Schemas are a collection of tables and other objects that are grouped with
+one another. You can create, modify, and delete them.
+
+
+.. toctree::
+   :maxdepth: 2
+
+   alter_schema
+   create_schema
+   drop_schema
+
+
+MySQL Compatibility:
+
+In Drizzle a "schema" is mapped to what MySQL refers to as a "database", and is stored in a "catalog".

=== added file 'docs/show.rst'
--- docs/show.rst	1970-01-01 00:00:00 +0000
+++ docs/show.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,30 @@
+SHOW
+=====
+
+All show commans are mapped to table functions in Drizzle. More data can be
+gained by exeucting queries directly on the tables found either the
+DATA_DICTIONARY or the INFORMATION_SCHEMA.
+
+SHOW SCHEMAS
+
+SHOW TABLES
+
+SHOW TEMPORARY TABLES
+
+SHOW TABLE STATUS
+
+
+SHOW COLUMNS FROM table_name 
+
+SHOW INDEXES from table_name
+
+
+SHOW WARNINGS
+
+SHOW ERRORS
+
+SHOW CREATE SCHEMA schema_name
+
+SHOW CREATE TABLE table_name
+
+SHOW PROCESSLIST

=== added file 'docs/storage_engines.rst'
--- docs/storage_engines.rst	1970-01-01 00:00:00 +0000
+++ docs/storage_engines.rst	2010-10-27 21:19:18 +0000
@@ -0,0 +1,10 @@
+Storage Engines
+===============
+
+Drizzle's micro-kernel has been designed to allow for data to be stored and
+provided for by different "engines". Engines differ in many ways, but the
+three primary types are, temporary only, transactional, and non-transaction.
+
+Drizzle runs by default with a transaction engine for both regular and
+temporary tables. You can override this behavior by specifing a different
+engine when creating a table.

=== added file 'docs/syslog.rst'
--- docs/syslog.rst	1970-01-01 00:00:00 +0000
+++ docs/syslog.rst	2010-10-27 21:19:18 +0000
@@ -0,0 +1,2 @@
+Unix Syslog
+===========

=== added file 'docs/tables.rst'
--- docs/tables.rst	1970-01-01 00:00:00 +0000
+++ docs/tables.rst	2010-10-27 21:00:49 +0000
@@ -0,0 +1,15 @@
+Tables
+=======
+
+A table makes up a collection of column_types that can be joined together in
+order to create relational result sets. Each record is called a row, and a
+table can have an infinite set of rows.
+
+.. toctree::
+   :maxdepth: 2
+
+   alter_table
+   create_table
+   drop_table
+   truncate 
+   rename

=== added file 'docs/transactional.rst'
--- docs/transactional.rst	1970-01-01 00:00:00 +0000
+++ docs/transactional.rst	2010-10-27 21:00:49 +0000
@@ -0,0 +1,12 @@
+TRANSACTIONAL
+============
+
+COMMIT
+
+BEGIN
+
+ROLLBACK
+
+SAVEPOINT
+
+RELEASE

=== added file 'docs/truncate.rst'
--- docs/truncate.rst	1970-01-01 00:00:00 +0000
+++ docs/truncate.rst	2010-10-27 20:46:04 +0000
@@ -0,0 +1,6 @@
+TRUNCATE
+========
+
+TRUNCATE TABLE table_name
+
+This will delete all data in a table but unlike a DROP TABLE it will keep all counters, such as a SERIAL, in place.

=== added file 'docs/update.rst'
--- docs/update.rst	1970-01-01 00:00:00 +0000
+++ docs/update.rst	2010-10-27 20:22:26 +0000
@@ -0,0 +1,10 @@
+Updating Data
+========
+
+In Dizzle you can make use of UPDATE to modify an existing record in a table.
+
+A type query:
+
+UPDATE TABLE_1 SET a="1";
+
+

=== added file 'docs/variables.rst'
--- docs/variables.rst	1970-01-01 00:00:00 +0000
+++ docs/variables.rst	2010-10-27 21:00:49 +0000
@@ -0,0 +1,4 @@
+User Variables
+==============
+
+SET @variable = "some string";

=== modified file 'drizzled/identifier/table.cc'
--- drizzled/identifier/table.cc	2010-10-22 18:12:14 +0000
+++ drizzled/identifier/table.cc	2010-10-26 21:56:22 +0000
@@ -322,10 +322,7 @@
   util::insensitive_hash hasher;
   hash_value= hasher(path);
 
-  key.resize(getKeySize());
-
-  std::copy(getSchemaName().begin(), getSchemaName().end(), key.begin());
-  std::copy(getTableName().begin(), getTableName().end(), key.begin() + getSchemaName().length() + 1);
+  key.set(getKeySize(), getSchemaName(), getTableName());
 }
 
 
@@ -367,9 +364,25 @@
   message.set_schema(getSchemaName());
 }
 
+void TableIdentifier::Key::set(size_t resize_arg, const std::string &a, const std::string &b)
+{
+  key_buffer.resize(resize_arg);
+
+  std::copy(a.begin(), a.end(), key_buffer.begin());
+  std::copy(b.begin(), b.end(), key_buffer.begin() + a.length() + 1);
+
+  util::sensitive_hash hasher;
+  hash_value= hasher(key_buffer);
+}
+
 std::size_t hash_value(TableIdentifier const& b)
 {
   return b.getHashValue();
 }
 
+std::size_t hash_value(TableIdentifier::Key const& b)
+{
+  return b.getHashValue();
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/identifier/table.h'
--- drizzled/identifier/table.h	2010-10-22 18:12:14 +0000
+++ drizzled/identifier/table.h	2010-10-26 21:56:22 +0000
@@ -58,7 +58,58 @@
 {
 public:
   typedef message::Table::TableType Type;
-  typedef std::vector<char> Key;
+
+  class Key
+  {
+    std::vector<char> key_buffer;
+    size_t hash_value;
+
+  public:
+
+    Key() :
+      hash_value(0)
+    {
+    }
+
+    const char *vector() const
+    {
+      return &key_buffer[0];
+    }
+
+    std::vector<char> &vectorPtr()
+    {
+      return key_buffer;
+    }
+
+    void set(size_t resize_arg, const std::string &a, const std::string &b);
+
+    friend bool operator==(const Key &left, const Key &right)
+    {
+      if (left.hash_value == right.hash_value and left.key_buffer.size() == right.key_buffer.size())
+      {
+        if (memcmp(&left.key_buffer[0], &right.key_buffer[0], left.key_buffer.size()) == 0)
+          return true;
+      }
+
+      return false;
+    }
+
+    friend bool operator<(const Key &left, const Key &right)
+    {
+      return left.key_buffer < right.key_buffer;
+    }
+
+    size_t size() const
+    {
+      return key_buffer.size();
+    }
+
+    size_t getHashValue() const
+    {
+      return hash_value;
+    }
+  };
+
 private:
 
   Type type;
@@ -235,6 +286,7 @@
 };
 
 std::size_t hash_value(TableIdentifier const& b);
+std::size_t hash_value(TableIdentifier::Key const& b);
 
 typedef std::vector <TableIdentifier> TableIdentifiers;
 

=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2010-10-11 21:57:03 +0000
+++ drizzled/item/sum.cc	2010-10-25 19:39:36 +0000
@@ -1027,7 +1027,7 @@
   field_def.init_for_tmp_table(table_field_type, args[0]->max_length,
                                args[0]->decimals, args[0]->maybe_null);
 
-  if (! (table= session->create_virtual_tmp_table(field_list)))
+  if (! (table= session->getInstanceTable(field_list)))
     return(true);
 
   /* XXX: check that the case of CHAR(0) works OK */

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-10-25 21:21:24 +0000
+++ drizzled/session.cc	2010-10-28 01:26:10 +0000
@@ -2085,4 +2085,34 @@
   return tmp_share;
 }
 
+
+/**
+  Create a reduced Table object with properly set up Field list from a
+  list of field definitions.
+
+    The created table doesn't have a table Cursor associated with
+    it, has no keys, no group/distinct, no copy_funcs array.
+    The sole purpose of this Table object is to use the power of Field
+    class to read/write data to/from table->getInsertRecord(). Then one can store
+    the record in any container (RB tree, hash, etc).
+    The table is created in Session mem_root, so are the table's fields.
+    Consequently, if you don't BLOB fields, you don't need to free it.
+
+  @param session         connection handle
+  @param field_list  list of column definitions
+
+  @return
+    0 if out of memory, Table object in case of success
+*/
+table::Instance *Session::getInstanceTable(List<CreateField> &field_list)
+{
+  temporary_shares.push_back(new table::Instance(this, field_list)); // This will not go into the tableshare cache, so no key is used.
+
+  table::Instance *tmp_share= temporary_shares.back();
+
+  assert(tmp_share);
+
+  return tmp_share;
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2010-10-27 01:49:45 +0000
+++ drizzled/session.h	2010-10-28 01:26:10 +0000
@@ -1585,6 +1585,7 @@
   void get_xid(DRIZZLE_XID *xid); // Innodb only
 
   table::Instance *getInstanceTable();
+  table::Instance *getInstanceTable(List<CreateField> &field_list);
 
 private:
   bool resetUsage()

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2010-10-25 23:36:21 +0000
+++ drizzled/sql_base.cc	2010-10-28 01:26:10 +0000
@@ -193,19 +193,6 @@
 
 static UnusedTables unused_tables;
 
-unsigned char *table_cache_key(const unsigned char *record,
-                               size_t *length,
-                               bool );
-
-unsigned char *table_cache_key(const unsigned char *record,
-                               size_t *length,
-                               bool )
-{
-  Table *entry=(Table*) record;
-  *length= entry->getShare()->getCacheKey().size();
-  return (unsigned char*) &entry->getShare()->getCacheKey()[0];
-}
-
 bool table_cache_init(void)
 {
   return false;
@@ -256,7 +243,7 @@
   const TableIdentifier::Key &key(identifier.getKey());
   TableShare *share= new TableShare(identifier.getType(),
                                     identifier,
-                                    const_cast<char *>(&key[0]),  static_cast<uint32_t>(table->getShare()->getCacheKeySize()));
+                                    const_cast<char *>(key.vector()),  static_cast<uint32_t>(table->getShare()->getCacheKeySize()));
 
   table->cursor->close();
   table->db_stat= 0;                            // Mark cursor closed

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-10-27 20:29:24 +0000
+++ drizzled/sql_yacc.yy	2010-10-28 01:45:34 +0000
@@ -4795,6 +4795,7 @@
           {}
         ;
 
+/* SHOW SCHEMAS */
 show_param:
            DATABASES show_wild
            {
@@ -4836,6 +4837,7 @@
               if (session->add_order_to_list(my_field, true))
                 DRIZZLE_YYABORT;
            }
+           /* SHOW TABLES */
          | TABLES opt_db show_wild
            {
              LEX *lex= Lex;
@@ -4896,6 +4898,7 @@
               if (session->add_order_to_list(my_field, true))
                 DRIZZLE_YYABORT;
            }
+           /* SHOW TEMPORARY TABLES */
          | TEMPORARY_SYM TABLES show_wild
            {
              LEX *lex= Lex;
@@ -4922,6 +4925,7 @@
              (session->lex->current_select->with_wild)++;
 
            }
+           /* SHOW TABLE STATUS */
          | TABLE_SYM STATUS_SYM opt_db show_wild
            {
              LEX *lex= Lex;
@@ -4964,6 +4968,7 @@
                DRIZZLE_YYABORT;
              (session->lex->current_select->with_wild)++;
            }
+           /* SHOW COLUMNS FROM table_name */
         | COLUMNS from_or_in table_ident opt_db show_wild
           {
              LEX *lex= Lex;
@@ -5006,6 +5011,7 @@
              (session->lex->current_select->with_wild)++;
 
           }
+          /* SHOW INDEXES from table */
         | keys_or_index from_or_in table_ident opt_db where_clause
           {
              LEX *lex= Lex;

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2010-10-22 17:44:34 +0000
+++ drizzled/table.cc	2010-10-25 19:39:36 +0000
@@ -1421,127 +1421,6 @@
 
 /****************************************************************************/
 
-/**
-  Create a reduced Table object with properly set up Field list from a
-  list of field definitions.
-
-    The created table doesn't have a table Cursor associated with
-    it, has no keys, no group/distinct, no copy_funcs array.
-    The sole purpose of this Table object is to use the power of Field
-    class to read/write data to/from table->getInsertRecord(). Then one can store
-    the record in any container (RB tree, hash, etc).
-    The table is created in Session mem_root, so are the table's fields.
-    Consequently, if you don't BLOB fields, you don't need to free it.
-
-  @param session         connection handle
-  @param field_list  list of column definitions
-
-  @return
-    0 if out of memory, Table object in case of success
-*/
-
-Table *Session::create_virtual_tmp_table(List<CreateField> &field_list)
-{
-  uint32_t field_count= field_list.elements;
-  uint32_t blob_count= 0;
-  Field **field;
-  CreateField *cdef;                           /* column definition */
-  uint32_t record_length= 0;
-  uint32_t null_count= 0;                 /* number of columns which may be null */
-  uint32_t null_pack_length;              /* NULL representation array length */
-
-  table::Instance *table= getInstanceTable(); // This will not go into the tableshare cache, so no key is used.
-  table->getMutableShare()->setFields(field_count + 1);
-  table->setFields(table->getMutableShare()->getFields(true));
-  field= table->getMutableShare()->getFields(true);
-  table->getMutableShare()->blob_field.resize(field_count+1);
-  table->getMutableShare()->fields= field_count;
-  table->getMutableShare()->blob_ptr_size= portable_sizeof_char_ptr;
-  table->setup_tmp_table_column_bitmaps();
-
-  table->in_use= this;           /* field->reset() may access table->in_use */
-
-  /* Create all fields and calculate the total length of record */
-  List_iterator_fast<CreateField> it(field_list);
-  while ((cdef= it++))
-  {
-    *field= table->getMutableShare()->make_field(NULL,
-                                                 cdef->length,
-                                                 (cdef->flags & NOT_NULL_FLAG) ? false : true,
-                                                 (unsigned char *) ((cdef->flags & NOT_NULL_FLAG) ? 0 : ""),
-                                                 (cdef->flags & NOT_NULL_FLAG) ? 0 : 1,
-                                                 cdef->decimals,
-                                                 cdef->sql_type,
-                                                 cdef->charset,
-                                                 cdef->unireg_check,
-                                                 cdef->interval,
-                                                 cdef->field_name);
-    if (!*field)
-      goto error;
-    (*field)->init(table);
-    record_length+= (*field)->pack_length();
-    if (! ((*field)->flags & NOT_NULL_FLAG))
-      null_count++;
-
-    if ((*field)->flags & BLOB_FLAG)
-      table->getMutableShare()->blob_field[blob_count++]= (uint32_t) (field - table->getFields());
-
-    field++;
-  }
-  *field= NULL;                             /* mark the end of the list */
-  table->getMutableShare()->blob_field[blob_count]= 0;            /* mark the end of the list */
-  table->getMutableShare()->blob_fields= blob_count;
-
-  null_pack_length= (null_count + 7)/8;
-  table->getMutableShare()->setRecordLength(record_length + null_pack_length);
-  table->getMutableShare()->rec_buff_length= ALIGN_SIZE(table->getMutableShare()->getRecordLength() + 1);
-  table->record[0]= (unsigned char*)alloc(table->getMutableShare()->rec_buff_length);
-  if (not table->getInsertRecord())
-    goto error;
-
-  if (null_pack_length)
-  {
-    table->null_flags= (unsigned char*) table->getInsertRecord();
-    table->getMutableShare()->null_fields= null_count;
-    table->getMutableShare()->null_bytes= null_pack_length;
-  }
-  {
-    /* Set up field pointers */
-    unsigned char *null_pos= table->getInsertRecord();
-    unsigned char *field_pos= null_pos + table->getMutableShare()->null_bytes;
-    uint32_t null_bit= 1;
-
-    for (field= table->getFields(); *field; ++field)
-    {
-      Field *cur_field= *field;
-      if ((cur_field->flags & NOT_NULL_FLAG))
-        cur_field->move_field(field_pos);
-      else
-      {
-        cur_field->move_field(field_pos, (unsigned char*) null_pos, null_bit);
-        null_bit<<= 1;
-        if (null_bit == (1 << 8))
-        {
-          ++null_pos;
-          null_bit= 1;
-        }
-      }
-      cur_field->reset();
-
-      field_pos+= cur_field->pack_length();
-    }
-  }
-
-  return table;
-
-error:
-  for (field= table->getFields(); *field; ++field)
-  {
-    delete *field;                         /* just invokes field destructor */
-  }
-  return 0;
-}
-
 void Table::column_bitmaps_set(boost::dynamic_bitset<>& read_set_arg,
                                boost::dynamic_bitset<>& write_set_arg)
 {

=== modified file 'drizzled/table/instance.cc'
--- drizzled/table/instance.cc	2010-10-22 23:03:02 +0000
+++ drizzled/table/instance.cc	2010-10-26 05:46:20 +0000
@@ -36,6 +36,105 @@
 namespace table
 {
 
+Instance::Instance(Session *session, List<CreateField> &field_list) :
+  _share(message::Table::INTERNAL),
+  _has_variable_width(false)
+{
+  uint32_t field_count= field_list.elements;
+  uint32_t blob_count= 0;
+  Field **field_arg;
+  CreateField *cdef;                           /* column definition */
+  uint32_t record_length= 0;
+  uint32_t null_count= 0;                 /* number of columns which may be null */
+  uint32_t null_pack_length;              /* NULL representation array length */
+
+  getMutableShare()->setFields(field_count + 1);
+  setFields(getMutableShare()->getFields(true));
+  field_arg= getMutableShare()->getFields(true);
+  getMutableShare()->blob_field.resize(field_count+1);
+  getMutableShare()->fields= field_count;
+  getMutableShare()->blob_ptr_size= portable_sizeof_char_ptr;
+  setup_tmp_table_column_bitmaps();
+
+  in_use= session;           /* field_arg->reset() may access in_use */
+
+  /* Create all fields and calculate the total length of record */
+  List_iterator_fast<CreateField> it(field_list);
+  while ((cdef= it++))
+  {
+    *field_arg= getMutableShare()->make_field(NULL,
+                                                 cdef->length,
+                                                 (cdef->flags & NOT_NULL_FLAG) ? false : true,
+                                                 (unsigned char *) ((cdef->flags & NOT_NULL_FLAG) ? 0 : ""),
+                                                 (cdef->flags & NOT_NULL_FLAG) ? 0 : 1,
+                                                 cdef->decimals,
+                                                 cdef->sql_type,
+                                                 cdef->charset,
+                                                 cdef->unireg_check,
+                                                 cdef->interval,
+                                                 cdef->field_name);
+    if (!*field_arg)
+    {
+      throw "Memory allocation failure";
+    }
+
+    (*field_arg)->init(this);
+    record_length+= (*field_arg)->pack_length();
+    if (! ((*field_arg)->flags & NOT_NULL_FLAG))
+      null_count++;
+
+    if ((*field_arg)->flags & BLOB_FLAG)
+      getMutableShare()->blob_field[blob_count++]= (uint32_t) (field_arg - getFields());
+
+    field_arg++;
+  }
+  *field_arg= NULL;                             /* mark the end of the list */
+  getMutableShare()->blob_field[blob_count]= 0;            /* mark the end of the list */
+  getMutableShare()->blob_fields= blob_count;
+
+  null_pack_length= (null_count + 7)/8;
+  getMutableShare()->setRecordLength(record_length + null_pack_length);
+  getMutableShare()->rec_buff_length= ALIGN_SIZE(getMutableShare()->getRecordLength() + 1);
+  record[0]= (unsigned char*)session->alloc(getMutableShare()->rec_buff_length);
+  if (not getInsertRecord())
+  {
+    throw "Memory allocation failure";
+  }
+
+  if (null_pack_length)
+  {
+    null_flags= (unsigned char*) getInsertRecord();
+    getMutableShare()->null_fields= null_count;
+    getMutableShare()->null_bytes= null_pack_length;
+  }
+  {
+    /* Set up field pointers */
+    unsigned char *null_pos= getInsertRecord();
+    unsigned char *field_pos= null_pos + getMutableShare()->null_bytes;
+    uint32_t null_bit= 1;
+
+    for (field_arg= getFields(); *field_arg; ++field_arg)
+    {
+      Field *cur_field= *field_arg;
+      if ((cur_field->flags & NOT_NULL_FLAG))
+        cur_field->move_field(field_pos);
+      else
+      {
+        cur_field->move_field(field_pos, (unsigned char*) null_pos, null_bit);
+        null_bit<<= 1;
+        if (null_bit == (1 << 8))
+        {
+          ++null_pos;
+          null_bit= 1;
+        }
+      }
+      cur_field->reset();
+
+      field_pos+= cur_field->pack_length();
+    }
+  }
+}
+
 bool Instance::open_tmp_table()
 {
   int error;

=== modified file 'drizzled/table/instance.h'
--- drizzled/table/instance.h	2010-10-21 08:01:16 +0000
+++ drizzled/table/instance.h	2010-10-25 19:39:36 +0000
@@ -41,6 +41,8 @@
   {
   }
 
+  Instance(Session *session, List<CreateField> &field_list);
+
   TableShare *getMutableShare(void)
   {
     return &_share;

=== modified file 'drizzled/table_share.cc'
--- drizzled/table_share.cc	2010-10-22 23:03:02 +0000
+++ drizzled/table_share.cc	2010-10-26 21:56:22 +0000
@@ -510,8 +510,8 @@
 
   if (type_arg == message::Table::INTERNAL)
   {
-    TableIdentifier::build_tmptable_filename(private_key_for_cache);
-    init(&private_key_for_cache[0], &private_key_for_cache[0]);
+    TableIdentifier::build_tmptable_filename(private_key_for_cache.vectorPtr());
+    init(private_key_for_cache.vector(), private_key_for_cache.vector());
   }
   else
   {
@@ -582,10 +582,10 @@
   table_category=         TABLE_CATEGORY_TEMPORARY;
   tmp_table=              message::Table::INTERNAL;
 
-  db.str= &private_key_for_cache[0];
-  db.length= strlen(&private_key_for_cache[0]);
+  db.str= const_cast<char *>(private_key_for_cache.vector());
+  db.length= strlen(private_key_for_cache.vector());
 
-  table_name.str= &private_key_for_cache[0] + strlen(&private_key_for_cache[0]) + 1;
+  table_name.str= const_cast<char *>(private_key_for_cache.vector()) + strlen(private_key_for_cache.vector()) + 1;
   table_name.length= strlen(table_name.str);
   path.str= (char *)"";
   normalized_path.str= path.str;
@@ -661,8 +661,8 @@
   {
     table_category=         TABLE_CATEGORY_TEMPORARY;
     tmp_table=              message::Table::INTERNAL;
-    db.str= &private_key_for_cache[0];
-    db.length= strlen(&private_key_for_cache[0]);
+    db.str= const_cast<char *>(private_key_for_cache.vector());
+    db.length= strlen(private_key_for_cache.vector());
     table_name.str= db.str + 1;
     table_name.length= strlen(table_name.str);
     path.str= &private_normalized_path[0];
@@ -744,7 +744,7 @@
     Let us use the fact that the key is "db/0/table_name/0" + optional
     part for temporary tables.
   */
-  db.str= &private_key_for_cache[0];
+  db.str= const_cast<char *>(private_key_for_cache.vector());
   db.length=         strlen(db.str);
   table_name.str=    db.str + db.length + 1;
   table_name.length= strlen(table_name.str);
@@ -819,14 +819,13 @@
 
 void TableShare::setIdentifier(TableIdentifier &identifier_arg)
 {
-  private_key_for_cache.clear();
   private_key_for_cache= identifier_arg.getKey();
 
   /*
     Let us use the fact that the key is "db/0/table_name/0" + optional
     part for temporary tables.
   */
-  db.str= &private_key_for_cache[0];
+  db.str= const_cast<char *>(private_key_for_cache.vector());
   db.length=         strlen(db.str);
   table_name.str=    db.str + db.length + 1;
   table_name.length= strlen(table_name.str);

=== modified file 'drizzled/util/string.h'
--- drizzled/util/string.h	2010-07-28 23:07:42 +0000
+++ drizzled/util/string.h	2010-10-26 21:56:22 +0000
@@ -70,6 +70,21 @@
   }
 };
 
+struct sensitive_hash : std::unary_function< std::vector<char>, std::size_t>
+{
+  std::size_t operator()(std::vector<char> const& x) const
+  {
+    std::size_t seed = 0;
+
+    for(std::vector<char>::const_iterator it = x.begin(); it != x.end(); ++it)
+    {
+      boost::hash_combine(seed, *it);
+    }
+
+    return seed;
+  }
+};
+
 } /* namespace util */
 } /* namespace drizzled */
 

=== modified file 'unittests/table_identifier.cc'
--- unittests/table_identifier.cc	2010-09-23 01:53:13 +0000
+++ unittests/table_identifier.cc	2010-10-26 21:56:22 +0000
@@ -64,13 +64,13 @@
   const TableIdentifier::Key key= identifier.getKey();
 
   EXPECT_EQ(key.size(), 7);
-  EXPECT_EQ(key[0], 't');
-  EXPECT_EQ(key[1], 'e');
-  EXPECT_EQ(key[2], 's');
-  EXPECT_EQ(key[3], 't');
-  EXPECT_EQ(key[4], 0);
-  EXPECT_EQ(key[5], 'a');
-  EXPECT_EQ(key[6], 0);
+  EXPECT_EQ(key.vector()[0], 't');
+  EXPECT_EQ(key.vector()[1], 'e');
+  EXPECT_EQ(key.vector()[2], 's');
+  EXPECT_EQ(key.vector()[3], 't');
+  EXPECT_EQ(key.vector()[4], 0);
+  EXPECT_EQ(key.vector()[5], 'a');
+  EXPECT_EQ(key.vector()[6], 0);
 }
 
 TEST(table_identifier_test_key, KeyCompare)

